
datablock fxDtsBrickData(ClassChangeBrickData : brick2x2RampPrintData)
{
	category = "Special";
	subcategory = "RPG";
	
	uiName = "Class Change";
	
	specialBrickType = "Class";
};

	
package BRPG_ClassChangeBrick
{
	function fxDtsBrick::onActivate(%obj, %player, %client, %pos, %vec)
	{
		if(%obj.dataBlock.specialBrickType $= "Class" && RPG_Minigamecheck(%client, 1))
		{
			messageClient(%client, '', "\c3Change Class");
			messageClient(%client, '', "\c31. \c6Change class");
			messageClient(%client, '', "\c32. \c6Reset character");
			messageClient(%client, '', "\c30. \c6Exit");
			
			if(%client.shopping)
				cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			%client.shoppingBrick = %obj;
		}
		Parent::OnActivate(%obj, %player, %client, %pos, %vec);
	}
	function ServerCmdMessageSent(%client, %text)
	{
		if(%client.shopping && %client.shoppingBrick.dataBlock.specialBrickType $= "Class" && RPG_Minigamecheck(%client, 1))
		{
			cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			
			switch$(%text)
			{
				case 1:
					messageClient(%client, '', "\c3You \c0may not\c3 change again once you have changed class!");
					messageClient(%client, '', "\c3Type one of the classes below.");
					messageClient(%client, '', "\c6Fighter");
					messageClient(%client, '', "\c6Archer");
					messageClient(%client, '', "\c6Mage");
				case 2:
					messageClient(%client, '', 'WARNING: \c3You will lose all items, exp and stats!');
					messageClient(%client, '', '\c3You will be able to choose a different class.');
					messageClient(%client, '', '\c6Say "resetchar" to reset your progress.');
					messageClient(%client, '', '\c6Say anything else to cancel.');
				case "Fighter":
					if(%client.RPG["class"] $= "Villager")
					{
						%client.RPG["class"] = "Fighter";
						messageClient(%client, '', "\c3You are now a \c2Fighter");
					}
					else
						messageClient(%client, '', '\c3You cannot change class again.');
					%client.stopShopping();
				case "Archer":
					if(%client.RPG["class"] $= "Villager")
					{
						%client.RPG["class"] = "Archer";
						messageClient(%client, '', "\c3You are now an \c2Archer");
					}
					else
						messageClient(%client, '', '\c3You cannot change class again.');
					%client.stopShopping();
				case "Mage":
					if(%client.RPG["class"] $= "Villager")
					{
						%client.RPG["class"] = "Mage";
						messageClient(%client, '', "\c3You are now a \c2Mage");
					}
					else
						messageClient(%client, '', '\c3You cannot change class again.');
					%client.stopShopping();
				case "resetchar":
					messageClient(%client, '', "\c3Your progress has been reset.");
					%client.checkPointBrick = "";
					%client.checkPointBrickPos = "";
					setDefaultValues(%client);
					%client.saveStats();
					%client.player.instantRespawn();
					%client.stopShopping();
				default:
					%client.stopShopping(1);
			}
		}
		else
			Parent::ServerCmdMessageSent(%client, %text);
	}
};activatepackage(BRPG_ClassChangeBrick);
