
datablock fxDtsBrickData(pawnShopBrickData : brick2x2RampPrintData)
{
	category = "Special";
	subcategory = "RPG";
	
	uiName = "Pawn Shop";
	
	specialBrickType = "Pawn";
};

	
package BRPG_PawnShopBrick
{
	function fxDtsBrick::OnActivate(%obj, %player, %client, %pos, %vec)
	{
		if(%obj.dataBlock.specialBrickType $= "Pawn" && RPG_Minigamecheck(%client, 1))
		{
			messageClient(%client, '', "\c3Pawn shop");
			messageClient(%client, '', "\c3Say the number of the item you wish to sell");
			for(%i = 0; %i < %player.dataBlock.maxTools; %i++)
			{
				%uiName = %player.tool[%i].uiName;
				%price = $ItemData::Price[%uiName];
				
				if(%price)
					messageClient(%client, '', "\c3" @ %i + 1 @ ". \c6" @ %uiName SPC "\c3[" @ mFloor(%price * 0.25) @ "]");
			}
			messageClient(%client, '', "\c30. \c6Exit");
			
			if(%client.shopping)
				cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			%client.shoppingBrick = %obj;
		}
		Parent::OnActivate(%obj, %player, %client, %pos, %vec);
	}
	function ServerCmdMessageSent(%client, %text)
	{
		if(%client.shopping && %client.shoppingBrick.dataBlock.specialBrickType $= "Pawn" && RPG_Minigamecheck(%client, 1))
		{
			cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			
			if(%text > 0 && %text <= %client.player.dataBlock.maxTools)
			{
				%price = mFloor($ItemData::Price[%client.player.tool[%text - 1].uiName] * 0.25);
				if(%price)
				{
					messageClient(%client, '', "\c3You pawned your\c2" SPC %client.player.tool[%text - 1].uiName SPC "\c3for\c2" SPC %price SPC "\c3gold");
					%client.player.tool[%text - 1] = "";
					messageClient(%client,'MsgItemPickup','',%text - 1,0);
					%client.RPG["gold"] += %price;
					%client.stopShopping(2);
				}
				else
				{
					messageClient(%client, '', "\c6I can't buy that...");
					%client.stopShopping();
				}
			}
			else
				%client.stopShopping(1);
		}
		else
			Parent::ServerCmdMessageSent(%client, %text);
	}
};activatepackage(BRPG_PawnShopBrick);
