
RegisterOutputEvent("fxDtsBrick", "ifRPGValue1", "list Level 0 Gold 1 HP 2 MP 3 Quests1 4 Quests2 5" TAB "int 0 999" TAB "list == 0 != 1 < 2 > 3 <= 4 >= 5" TAB "int 0 999", 3);
RegisterInputEvent(fxDtsBrick, "onRPGTrue1", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
RegisterInputEvent(fxDtsBrick, "onRPGFalse1", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
function fxDtsBrick::ifRPGValue1(%brick, %var, %quest, %op, %val, %client)
{
	%brick.checkRPGValue(%var, %quest, %op, %val, %client, 1);
}

RegisterOutputEvent("fxDtsBrick", "ifRPGValue2", "list Level 0 Gold 1 HP 2 MP 3 Quests1 4 Quests2 5" TAB "int 0 999" TAB "list == 0 != 1 < 2 > 3 <= 4 >= 5" TAB "int 0 999", 3);
RegisterInputEvent(fxDtsBrick, "onRPGTrue2", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
RegisterInputEvent(fxDtsBrick, "onRPGFalse2", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
function fxDtsBrick::ifRPGValue2(%brick, %var, %quest, %op, %val, %client)
{
	%brick.checkRPGValue(%var, %quest, %op, %val, %client, 2);
}

RegisterOutputEvent("fxDtsBrick", "ifRPGValue3", "list Level 0 Gold 1 HP 2 MP 3 Quests1 4 Quests2 5" TAB "int 0 999" TAB "list == 0 != 1 < 2 > 3 <= 4 >= 5" TAB "int 0 999", 3);
RegisterInputEvent(fxDtsBrick, "onRPGTrue3", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
RegisterInputEvent(fxDtsBrick, "onRPGFalse3", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
function fxDtsBrick::ifRPGValue3(%brick, %var, %quest, %op, %val, %client)
{
	%brick.checkRPGValue(%var, %quest, %op, %val, %client, 3);
}

function fxDtsBrick::checkRPGValue(%brick, %var, %quest, %op, %val, %client, %num)
{
	if(!RPG_Minigamecheck(%client, 1))
		 return;
		 
	switch(%var)
	{
		case 0:
			%str = "level";
			%quest = "";
		case 1:
			%str = "gold";
			%quest = "";
		case 2:
			%str = "hp";
			%quest = "";
		case 3:
			%str = "mp";
			%quest = "";
		case 4:
			%str = "quest_1-";
		case 5:
			%str = "quest_2-";
	}
	switch(%op)
	{
		case 0:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] == %val, %num);
		case 1:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] != %val, %num);
		case 2:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] < %val, %num);
		case 3:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] > %val, %num);
		case 4:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] <= %val, %num);
		case 5:
			%brick.triggerRPGValueEvent(%client, %client.RPG[%str @ %quest] >= %val, %num);
	}
}

function fxDtsBrick::triggerRPGValueEvent(%brick, %client, %result, %num)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Client"] = %client;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Minigame"] = %client.minigame;
	if(%result)
		%brick.processInputEvent("onRPGTrue" @ %num, %client);
	else
		%brick.processInputEvent("onRPGFalse" @ %num, %client);
}

//RegisterInputEvent(fxDtsBrick, "onPlayerSpawnHere", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");
//package BRPG_playerSpawn
//{
//	function GameConnection::getSpawnPoint(%client)
//	{
//		$RPG_temp = %client;
//		parent::getSpawnPoint(%client);
//	}
//	function fxDtsBrick::getSpawnPoint(%brick)
//	{
//		//echo("brick:" SPC %brick);
//		//echo("client:" SPC $RPG_temp);
//		%client = $RPG_temp;
//		%brick.schedule(33, triggerPlayerSpawnEvent, %client);
//		parent::getSpawnPoint(%brick);
//	}
//};activatepackage(BRPG_playerSpawn);

function fxDtsBrick::triggerPlayerSpawnEvent(%this, %client)
{
	$InputTarget_["Self"] = %this;
	$InputTarget_["Client"] = %client;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Minigame"] = %client.minigame;
	%this.processInputEvent("onPlayerSpawnHere", %client);
}

RegisterOutputEvent("GameConnection", "SetQuest", "list Hills 1 Dark_Forest 2 Field 3 Northlands 4 Loading 0" TAB "int 0 999" TAB "list = 0 + 1 - 2" TAB "int 0 999", 3);
function GameConnection::SetQuest(%client, %region,%quest, %op, %val)
{
	if(!RPG_Minigamecheck(%client, 1))
		 return;
		 
	%str = "quest_" @ %region @ "-" @ %quest;
	%prev = %client.RPG[%str];
	switch(%op)
	{
		case 0:
			%client.RPG[%str] = %val;
		case 1:
			%client.RPG[%str] += %val;
		case 2:
			%client.RPG[%str] -= %val;
	}
	if(%client.RPG[%str] != 0 && %prev == 0)
		%client.questStarted(%str);
	if(%client.RPG[%str] == 1&& %prev != 1)
		%client.questCompleted(%str);
}

registerOutputEvent("Player", "AddMP", "int -999999 999999", 4);
function Player::AddMP(%player,%amount)
{
	if(!RPG_Minigamecheck(%player.client, 1))
		 return;
	%MP = %player.getEnergyLevel() / 100 * %player.client.RPG["maxmp"];
	%player.setEnergyLevel((%MP + %amount) / %player.client.RPG["maxmp"] * 100);
	updateMP(%player.client);
	//%player.client.displayinfo();
}

registerOutputEvent("Player", "SetEnergy", "int 0 100", 3);
function Player::SetEnergy(%player,%amount)
{
	if(!RPG_Minigamecheck(%player.client, 1))
		 return;
	%player.setEnergyLevel(%amount);
	updateMP(%player.client);
	//%player.client.displayinfo();
}

registerOutputEvent("GameConnection", "SetRegion", "int 0 999", 2);
function GameConnection::setRegion(%client, %region)
{
	if(!RPG_Minigamecheck(%client, 1))
		 return;
		 
	if(%region != %client.RPG["region"])
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			if(%target.RPG["region"] == %region && $RPG_localChatEnabled)
				messageClient(%target, '', '\c3%1 has entered \c2%2', %client.name, $RPG_region[%region]);
		}
		
		%oldRegion = %client.RPG["region"];
		%client.RPG["region"] = %region;

		if($RPG_localChatEnabled)
			messageClient(%client, '', '\c3Now entering \c2%1', $RPG_region[%region]);
			
		if(%oldRegion == 0)
			return;
		
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			if(%target.RPG["region"] == %oldRegion && $RPG_localChatEnabled)
				messageClient(%target, '', '\c3%1 has left \c2%2', %client.name, $RPG_region[%oldRegion]);
		}
	}
}

registerOutputEvent("GameConnection", "SetDistrict", "int 0 999", 2);
function GameConnection::setDistrict(%client, %district)
{
	if(!RPG_Minigamecheck(%client, 1))
		 return;
		 
	if(%district != %client.RPG["district"])
	{
		%originallyEmpty = true;
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			if(%target.RPG["district"] == %district)
			{
				%originallyEmpty = false;
				break;
			}
		}
		
		%oldDistrict = %client.RPG["district"];
		%client.RPG["district"] = %district;
		echo("Entering district" SPC %district);
		
		if(%originallyEmpty)
		{
			for(%i = 1; %i <= $RPG_botsInDistrict[%district]; %i++)
				$RPG_districtBrickTable[%district SPC %i].schedule(33 * %i, respawnVehicle);
		}
		%empty = true;
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			if(%target.RPG["district"] == %oldDistrict)
			{
				%empty = false;
				break;
			}
		}
		if(%empty)
		{
			for(%i = 1; %i <= $RPG_botsInDistrict[%oldDistrict]; %i++)
				$RPG_districtBrickTable[%oldDistrict SPC %i].vehicle.schedule(33 * %i, delete);
		}
	}
}

registerOutputEvent("fxDTSBrick", "AssignBotToDistrict", "int 0 999", 2); // string ? - bot, not fxDTSBrick ?
function fxDTSBrick::AssignBotToDistrict(%brick, %district)
{
	//echo("%district:" SPC %district);
	//echo("%brick.district:" SPC %brick.district);
	if(%district $= %brick.district)
		return;
	if(%brick.district $= "")
	{
		$RPG_botsInDistrict[%district]++;
		$RPG_districtBrickTable[%district SPC $RPG_botsInDistrict[%district]] = %brick;
		%brick.districtIndex = $RPG_botsInDistrict[%district];
		%brick.district = %district;
	}
	else
	{
		for(%i = %brick.districtIndex; %i < $RPG_botsInDistrict[%brick.district]; %i++)
		{
			//echo("%i:" SPC %i);
			%index = %brick.district SPC %i;
			%indexNew = %brick.district SPC %i + 1;
			//echo("old brick:" SPC $RPG_districtBrickTable[%index]);
			$RPG_districtBrickTable[%index] = $RPG_districtBrickTable[%indexNew];
			//echo("new brick:" SPC $RPG_districtBrickTable[%index]);
		}
		$RPG_botsInDistrict[%brick.district]--;
		//echo("botsInDistrict:" SPC $RPG_botsInDistrict[%brick.district]);
		if(%district !$= "")
		{
			$RPG_botsInDistrict[%district]++;
			$RPG_districtBrickTable[%district SPC $RPG_botsInDistrict[%district]] = %brick;
			%brick.districtIndex = $RPG_botsInDistrict[%district];
			%brick.district = %district;
		}
	}
	%brick.botDistrictCheck();
}
function fxDTSBrick::botDistrictCheck(%brick)
{
	if(%brick.district !$= "")
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%client = ClientGroup.getObject(%i);
			if(%client.RPG["district"] == %brick.district)
				return true;
		}
		if(isObject(%brick.vehicle))
			%brick.vehicle.delete();
		return false;
	}
}
package districts
{
	function fxDTSBrick::onDeath(%brick)
	{
		if(%brick.district !$= "")
			%brick.AssignBotToDistrict();
		parent::onDeath(%brick);
	}
	function fxDTSBrick::spawnVehicle(%brick)
	{
		Parent::spawnVehicle(%brick);
		%brick.schedule(100,botDistrictCheck);
	}
};activatepackage(districts);