
if(!isFile("config/server/BasicRPG/itemData.txt"))
{
	$readFile = new fileObject();
	$readFile.openForWrite("config/server/BasicRPG/itemData.txt");
	$readFile.writeLine("[Name]" TAB "[Price]" TAB "[Type]" TAB "[Atk]" TAB "[R.Atk]" TAB "[Stock]" TAB "[MPcost]");
	$readFile.writeLine("Gun" TAB "50" TAB "Gun" TAB "30");
	$readFile.writeLine("Bow" TAB "10" TAB "Bow" TAB "10");
	$readFile.writeLine("Cape" TAB "100" TAB "Pack");
	$readFile.writeLine("Spear" TAB "15" TAB "Spear" TAB "10" TAB "10" TAB "20");
	$readFile.writeLine("Sword" TAB "20" TAB "Sword" TAB "10");
	$readFile.writeLine("Quiver" TAB "80" TAB "Pack");
	$readFile.writeLine("Pickaxe" TAB "0" TAB "Pick" TAB "0");
	$readFile.writeLine("Hammer " TAB "0" TAB "Pick" TAB "0");
	$readFile.writeLine("");
	$readFile.writeLine("Backpack" TAB "800" TAB "Pack");
	$readFile.writeLine("Iron Armor" TAB "250" TAB "Armor");
	$readFile.writeLine("RPG Pickaxe" TAB "0" TAB "Pick" TAB "0");
	$readFile.writeLine("Guns Akimbo" TAB "150" TAB "Gun" TAB "30");
	$readFile.writeLine("Leather Armor" TAB "60" TAB "Armor");
	$readFile.writeLine("Rocket Launcher" TAB "500" TAB "Gun" TAB "30" TAB "100");
	$readFile.close();
	$readFile.delete();
}

$readFile = new fileObject();
$readFile.openForRead("config/server/BasicRPG/itemData.txt");
while(!$readFile.isEOF())
{
	$readLine = $readFile.readLine();
	$ItemData::Price[getField($readLine,0)] = getField($readLine,1);
	$ItemData::Type[getField($readLine,0)] = getField($readLine,2);
	$ItemData::Attack[getField($readLine,0)] = getField($readLine,3);
	$ItemData::RadiusAttack[getField($readLine,0)] = getField($readLine,4);
	$ItemData::Stock[getField($readLine,0)] = getField($readLine,5);
	$ItemData::MPcost[getField($readLine,0)] = getField($readLine,6);
}
$readFile.close();
$readFile.delete();

package weaponRestrictions
{
	function serverCmdUseTool(%client, %slot)
	{
		if(!RPG_MinigameCheck(%client))
			return Parent::serverCmdUseTool(%client, %slot);
		
		%class = %client.RPG["class"];
		switch$ ($ItemData::Type[%client.player.tool[%slot].uiName])
		{
			case "Sword":
				if(%class !$= "Fighter")
				{
					commandToClient(%client, 'centerPrint', "Your class can not use swords", 2);
					serverCmdUnUseTool(%client, %slot);
					return;
				}   
			case "Spear":
				if(%class !$= "Fighter")
				{
					commandToClient(%client, 'centerPrint', "Your class can not use spears", 2);
					serverCmdUnUseTool(%client, %slot);
					return;
				}
			case "Bow":
				if(%class !$= "Archer")
				{
					commandToClient(%client, 'centerPrint', "Your class can not use bows", 2);
					serverCmdUnUseTool(%client, %slot);
					return;
				}
			case "Magic":
				if(%class !$= "Mage")
				{
					commandToClient(%client, 'centerPrint', "Your class can not use spells", 2);
					serverCmdUnUseTool(%client, %slot);
					return;
				}
		}
		Parent::serverCmdUseTool(%client, %slot);
	}
};activatepackage(weaponRestrictions);

package LastUsedTool
{
	function serverCmdUseTool(%client, %slot)
	{
		Parent::serverCmdUseTool(%client, %slot);
		%client.player.lastUsedTool = %slot;
	}
	function serverCmdUnUseTool(%client)
	{
		if(%client.player.currTool >= 0)
			%client.player.lastUsedTool = %client.player.currTool;
		Parent::serverCmdUnUseTool(%client);
	}
};
activatePackage(LastUsedTool);

package rememberImage
{
	function WeaponImage::onFire(%this,%obj,%slot)
	{
		%proj = parent::onFire(%this,%obj,%slot);
		%proj.dataBlock.image = %this;
		return %proj;
	}
};activatepackage(rememberImage);

package MPCost
{
   function WeaponImage::onFire(%this,%obj,%slot)	
   {
		if(!RPG_MinigameCheck(%obj.client))
			return Parent::onFire(%this, %obj, %slot);

      if($ItemData::MPcost[%this.item.uiName] > 0)
      {
         %MPcost = $ItemData::MPcost[%this.item.uiName];
         %energyCost = %MPcost / %obj.client.RPG["maxmp"] * %obj.client.player.dataBlock.maxEnergy;
         if(%obj.client.player.hasEnergy(%energyCost))
         {
            %obj.client.player.setEnergyLevel(%obj.client.player.getEnergyLevel() - %energyCost);
            %ret = parent::onFire(%this,%obj,%slot);
            updateMP(%obj.client);
            return %ret;
         }
         else %obj.client.centerPrint("Not enough MP!",3);
      }
      else parent::onFire(%this,%obj,%slot);
   }
};activatepackage(MPCost);

package RPG_ItemDurabilityCheck
{
	function WeaponImage::onFire(%this,%obj,%slot)	
	{
		if(RPG_MinigameCheck(%obj.client))
			return Parent::onFire(%this, %obj, %slot);

		if($ItemData::Stock[%this.item.uiName] > 0 && $ItemData::Type[%this.item.uiName] !$= "Bow")
		{
			%client = %obj.client;
			%player = %client.player;
			if(%player.durability[%player.currTool] $= "")
				%player.durability[%player.currTool] = $ItemData::Stock[%this.item.uiName];
			if(%player.durability[%player.currTool] > 0)
			{
				%player.durability[%player.currTool]--;
				updateDurability(%client);
				displayDurability(%player, %player.currTool);
				parent::onFire(%this,%obj,%slot);
			}
			else
				commandToClient(%client, 'centerPrint', "Out of ammunition!", 2);
		}
		else
			parent::onFire(%this,%obj,%slot);
	}
};activatepackage(RPG_ItemDurabilityCheck);

package itemUsage
{
	function WeaponImage::onFire(%this,%obj,%slot)
	{
		gunImage.item = gunItem;
		akimboGunImage.item = gunItem;
		leftHandedGunImage.item = gunItem;
		rocketLauncherImage.item = rocketLauncherItem;
	
		%client = %obj.client;
		%player = %client.player;
		
		if(!RPG_MinigameCheck(%client))
			return Parent::onFire(%this, %obj, %slot);

		if(%client.RPG["level"])
		{
			switch$($ItemData::Type[%this.item.uiName])
			{
				case "Bow":
					if(%client.RPG["arrows"] > 0)
					{
						%client.RPG["arrows"]--;
						displayDurability(%player, %player.currTool);
						parent::onFire(%this,%obj,%slot);
					}
					else
					{
						commandToClient(%client, 'centerPrint', "Out of arrows!", 2);
						displayDurability(%player, %player.currTool);
					}
				case "Armor":
					echo(%this.item.uiName);
					switch$(%this.item.uiName)
					{
						case "Leather Armor":
							if(%client.RPG["class"] $= "Mage" || %client.RPG["class"] $= "Villager")
							{
								commandToClient(%client, 'centerPrint', "Your class can not use this item", 2);
								return;
							}
						case "Iron Armor":
							if(%client.RPG["class"] !$= "Fighter")
							{
								commandToClient(%client, 'centerPrint', "Your class can not use this item", 2);
								return;
							}
					}
					%client.player.tool[%client.player.currTool] = "";
					%client.player.weaponCount--;
					messageClient(%client,'MsgItemPickup','',%client.player.currTool,0);
					if(serverCmdRemoveArmor(%client))
					{
						%client.RPG["armor"] = %this.item.uiName;
						accessoryCheck(%client);
					}
					else
					{
						%client.player.tool[%client.player.currTool] = %this.item;
						%client.player.weaponCount++;
						messageClient(%client,'MsgItemPickup','',%client.player.currTool,%this.item);
					}
				case "Pack":
					switch$(%this.item.uiName)
					{
						case "Quiver":
							if(%client.RPG["class"] !$= "Archer")
							{
								commandToClient(%client, 'centerPrint', "Your class can not use this item", 2);
								return;
							}
					}
					%client.player.tool[%client.player.currTool] = "";
					%client.player.weaponCount--;
					messageClient(%client,'MsgItemPickup','',%client.player.currTool,0);
					if(serverCmdRemovePack(%client))
					{
						%client.RPG["pack"] = %this.item.uiName;
						accessoryCheck(%client);
					}
					else
					{
						%client.player.tool[%client.player.currTool] = %this.item;
						%client.player.weaponCount++;
						messageClient(%client,'MsgItemPickup','',%client.player.currTool,%this.item);
					}
				default:
					Parent::onFire(%this,%obj,%slot);
			}
		}
		else
			Parent::onFire(%this,%obj,%slot);
	}
};activatepackage(itemUsage);

package RPG_ItemHit
{
	function Projectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		%client = %obj.sourceObject.client;
		if(%client.RPG["level"] && RPG_Minigamecheck(%client, 1))
		{
			switch$($ItemData::Type[%this.item.uiName])
			{
				case "Pick":
					mineOre(%client, %col);
				default:
					Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			}
		}
		else
			Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	}
};
activatePackage(RPG_ItemHit);


/////////////////////////////
//    Durability System  //
/////////////////////////////

function GameConnection::applyDurability(%client)
{
	%player = %client.player;
	%durability = %client.RPG["durability"];
	echo(%durability);
	for (%i = 0; %i < %player.getDatablock().maxTools; %i++)
	{
		%player.durability[%i] = getField(%durability, %i);
	}
}

function updateDurability(%client)
{
	if(isObject(%client.player))
	{
		%player = %client.player;
		%durability = %player.durability[0];
		if(%durability $= "")
			%durability = "-";
		for (%i = 1; %i < %player.getDatablock().maxTools; %i++)
		{
			%dur = %player.durability[%i];
			if(%dur $= "")
				%dur = "-";
			%durability = %durability TAB %dur;
			//%durability = (%durability $= "") ? %player.durability[%i] : %durability TAB %player.durability[%i];
		}
		%client.RPG["durability"] = %durability;
	}
}

function displayDurability(%obj, %slot, %a)
{
	if($ItemData::Type[%obj.tool[%slot].uiName] $= "Bow" || %a == 1)
	{
		%uiName = "Arrows";
		if(%obj.client.RPG["maxarrows"] == 0)
		{
			%obj.client.RPG["maxarrows"] = 50;
			%obj.client.RPG["arrows"] = 50;
		}
		%maxDur = %obj.client.RPG["maxarrows"];
		%durability = %obj.client.RPG["arrows"];
	}
	else
	{
		%uiName = %obj.tool[%slot].uiName;
		%maxDur = $ItemData::Stock[%obj.tool[%slot].uiName];
		%durability = %obj.durability[%slot];
		if(%obj.durability[%slot] $= "")
		{
			%obj.durability[%slot] = %maxDur;
			%durability = %obj.durability[%slot];
		}
	}
	
	if(%durability == %maxDur)
		%durability2 = %durability - 1;
	else
		%durability2 = %durability;

	if(isObject(%obj.client))
	{
		%hexStr = "0123456789ABCDEF";
		%greenPos = mFloatLength(((%durability2 / %maxDur) * 16 * 16),0);
		%greenPos1 = mFloatLength((%greenPos - (%greenPos % 16))/16,0);
		%greenPos2 = (%greenPos - 1) % 16;
		if(%greenPos - 1 < 0)
			%greenPos2 = 0;
		%red = getSubStr(%hexStr,15 - %greenPos1,1) @ getSubStr(%hexStr,15 - %greenPos2,1);
		%green = getSubStr(%hexStr,%greenPos1,1) @ getSubStr(%hexStr,%greenPos2,1);
		%colorStr = %red @ %green @ "00";
		%msg = "<br><br><br><br><br><br><br><just:right>\c6" @ %uiName @ ": <color:" @ %colorStr @ ">" @ %durability @ " ";
		centerPrint(%obj.client,%msg,2,2);
	}
}

package System_WeaponDurability
{
	function serverCmdDropTool(%client,%slot)
	{
		if(isObject(%client.player) && %client.player.tool[%slot] > 0)
			$ItemSpawn[$ItemSpawnCount++ - 1] = %client.player.tool[%slot] TAB %client.player TAB %slot;
		parent::serverCmdDropTool(%client,%slot);
	}
	function ItemData::onAdd(%db,%this)
	{
		for(%i = 0; %i < $ItemSpawnCount; %i++)
		{
			if(getField($ItemSpawn[%i],0) $= %db)
			{
				%this.durability = getField($ItemSpawn[%i],1).durability[getField($ItemSpawn[%i],2)];
				getField($ItemSpawn[%i],1).durability[getField($ItemSpawn[%i],2)] = "";
				%erase = 1;
			}
			if(%erase)
				$ItemSpawn[%i] = $ItemSpawn[%i + 1];
		}
		if(%erase)
			$ItemSpawnCount--;
		parent::onAdd(%db,%this);
	}
	function ItemData::onPickup(%db,%this,%obj,%a)
	{
		if(%this.durability $= "" && strLen($ItemData::Type[%db.uiName]) > 0)
			%this.durability = $ItemData::Stock[%db.uiName];
		%durability = %this.durability;
		parent::onPickup(%db,%this,%obj,%a);
		if(strPos(%obj.getClassname(),"Player") >= 0)
		{
			for(%i = 0; %i < %obj.getDatablock().maxTools; %i++)
			{
				if(%obj.tool[%i] $= %db)
				{
					if(%obj.durability[%i] $= "")
					{
						%obj.durability[%i] = %durability;
						break;
					}
				}
			}
		}
	}
	function WeaponImage::onMount(%this, %obj, %slot)
	{
		if ($ItemData::Stock[%obj.tool[%obj.currtool].UIname] > 0 || $ItemData::Type[%obj.tool[%obj.currtool].UIname] $= "Bow")
			displayDurability(%obj, %obj.currTool);
		parent::onMount(%this, %obj, %slot);
	}
};
activatePackage(System_WeaponDurability);
