
if(!isObject($RPG_fileObject))
	$RPG_fileObject = new fileObject();

if(!isFile("config/server/BasicRPG/shopData.txt"))
{
	$readFile = new fileObject();
	$readFile.openForWrite("config/server/BasicRPG/shopData.txt");
	$readFile.writeLine("");
	$readFile.writeLine("Weapon Shop");
	$readFile.writeLine("  Sword");
	$readFile.writeLine("  Bow");
	$readFile.writeLine("  Spear");
	$readFile.writeLine("");
	$readFile.writeLine("Accessory Shop");
	$readFile.writeLine("  Leather Armor");
	$readFile.writeLine("  Iron Armor");
	$readFile.writeLine("  Quiver");
	$readFile.writeLine("  Cape");
	$readFile.writeLine("  Backpack");
	$readFile.writeLine("");
	$readFile.writeLine("Item Shop");
	$readFile.writeLine("  Arrows");
	$readFile.close();
	$readFile.delete();
}

$RPG_fileObject.openForRead("config/server/BasicRPG/shopData.txt");

// Clear all shops
for(%i = 1; $RPG_shop[%i] !$= ""; %i++)
{
	//echo("Shop:" SPC $RPG_shop[%i]);
	for(%j = 0; $RPG_shop[%i].cat[%j] !$= "";%j++)
	{
		//echo("Cat:" SPC $RPG_shop[%i].cat[%j]);
		for(%k = 1; $RPG_shop[%i].item[%j @ "_" @ %k] !$= "";%k++)
		{
			//echo("Item:" SPC $RPG_shop[%i].item[%j @ "_" @ %k]);
			$RPG_shop[%i].item[%j @ "_" @ %k] = "";
		}
		$RPG_shop[%i].cat[%j] = "";
	}
	$RPG_shop[%i] = "";
}

while(!$RPG_fileObject.isEOF())
{
	%line = $RPG_fileObject.readLine();
	if(%line $= "")
		continue;
	
	if(getSubStr(%line, 0, 1) !$= " ")
	{
		%shop = stripChars(%line, " ") @ "BrickData";
		if(!isObject(%shop))
		{
			datablock fxDtsBrickData(ShopBrickData : brick2x2RampPrintData)
			{
				category = "Special";
				subcategory = "RPG";
			
				uiName = %line;
			
				specialBrickType = "Shop";
			};
			ShopBrickData.setName(%shop);
		}
		
		%line = $RPG_fileObject.readLine();
		%catCount = 0;
		%itemCount = 0;
		while(getSubStr(%line, 0, 1) $= " ")
		{
			if(getSubStr(%line, 0, 2) $= "  ")
			{
				%itemCount++;
				%shop.item[%catCount @ "_" @ %itemCount] = ltrim(%line);
			}
			else
			{
				%catCount++;
				%itemCount = 0;
				%shop.cat[%catCount] = ltrim(%line);
			}
			%line = $RPG_fileObject.readLine();
		}	
		%shop.cat[0] = "None";
		%shops++;
		$RPG_shop[%shops] = %shop;
	}
}
$RPG_fileObject.close();

package BRPG_Shops
{
	function fxDTSBrick::onActivate(%obj, %player, %client, %pos, %vec)
	{
		if(%obj.dataBlock.specialBrickType $= "Shop" && RPG_Minigamecheck(%client, 1))
		{
			messageClient(%client, '', "\c3" @ %obj.dataBlock.uiName);
			for(%i = 1; %obj.dataBlock.cat[%i] !$= ""; %i++)
				messageClient(%client, '', "\c3" @ %i @ "." SPC "\c6" @ %obj.dataBlock.cat[%i]);
			%client.displayItems(%obj.dataBlock, 0);
			messageClient(%client, '', "\c30. \c6Exit");
				
			if(%client.shopping)
				cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			%client.shoppingBrick = %obj;
		}
		Parent::onActivate(%obj, %player, %client, %pos, %vec);
	}
	function serverCmdMessageSent(%client, %text)
	{
		if(%client.shopping && %client.shoppingBrick.dataBlock.specialBrickType $= "Shop" && RPG_Minigamecheck(%client, 1))
		{
			cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			%shop = %client.shoppingBrick.dataBlock;
			
			if(%text != 0)
			{
				if(%shop.cat[%text] !$= "")
					%client.displayItems(%shop, %text);
				else
					%client.stopShopping(3);
			}
			else
				if(%text $= "0")
					%client.stopShopping(1);
				else
				{
					for(%i = 0; %shop.cat[%i] !$= ""; %i++)
						for(%j = 1; %shop.item[%i @ "_" @ %j] !$= ""; %j++)
							if(%shop.item[%i @ "_" @ %j] $= %text)
							{
								%client.stopShopping(%client.buyItem(%text));
								return;
							}
					%client.stopShopping(4);
					return;
				}
		}
		else
			Parent::ServerCmdMessageSent(%client, %text);
	}
};activatepackage(BRPG_Shops);

function GameConnection::displayItems(%client, %shop, %cat)
{
	if(%cat)
		messageClient(%client, '', "\c3" @ %shop.cat[%cat]);
	for(%i = 1; %shop.item[%cat @ "_" @ %i] !$= ""; %i++)
	{
		%item = %shop.item[%cat @ "_" @ %i];
		switch$(getSubStr(%item, 0, 1))
		{
			case "<":
				messageClient(%client, '', %item);
			default:
				%price = $ItemData::Price[%item];
				switch(strlen(%price))
				{
					case 0:
						%spaces = "       ";
					case 1:
						%spaces = "    ";
					case 2:
						%spaces = "   ";
					case 3:
						%spaces = " ";
					case 4:
						%spaces = " ";
					default:
						%spaces = "";
				}
				messageClient(%client, '', "\c3[" @ %spaces @ %price @ "]" SPC "\c6" @ %item);
		}
	}
}

function GameConnection::BuyItem(%client, %text)
{
	if (%text $= "")
		return 1;
	
	if(%text $= "Arrows")
	{
		updateArrows(%client);
		%player = %client.player;
		%price = mCeil((%client.RPG["maxarrows"] - %client.RPG["arrows"]) / 10);

		if(%price <= 0)
		{
			commandToClient(%client, 'centerPrint', "You already have maximum arrows!", 2);
			return 1;
		}

		if(%client.RPG["gold"] >= %price)
		{
			%client.RPG["arrows"] = %client.RPG["maxarrows"];
			%client.RPG["gold"] -= %price;
			displayDurability(%player, '', 1);
			return 2;
		}
		else 
		{
			%client.RPG["arrows"] += %client.RPG["gold"] * 10;
			%client.RPG["gold"] = 0;
			commandToClient(%client, 'centerPrint', "Not enough gold!", 2);
			return 1;
		}
	}
	
	%player = %client.player;
	%item = $uiNameTable_Items[%text];
	%price = $ItemData::Price[%text];

	if(!%item) return 1;

	if(%client.RPG["gold"] < %price)
	{
		commandToClient(%client, 'centerPrint', "Not enough gold!", 2);
		return 1;
	}
	
	if(!Player::giveItem(%player, %item, %client))
	{
		commandToClient(%client, 'centerPrint', "Your inventory is full!", 2);
		%client.stopActivate();
		return 1;
	}
	
	%client.RPG["gold"] -= %price;
	return 2;
}

function Player::giveItem(%player,%item)
{
	for(%i = 0; %i < %player.getDatablock().maxTools; %i++)
	{
		if(%player.tool[%i] == 0)
		{
			%player.tool[%i] = %item;
			%player.weaponCount++;
			messageClient(%player.client,'MsgItemPickup','',%i,%item);
			return true;
		}
	}
	return false;
}

function GameConnection::StopShopping(%client, %a)
{
	if(%client.shopping)
	{
		switch(%a)
		{
			case 1:
				messageClient(%client, '', "\c6Come again.");
			case 2:
				messageClient(%client, '', "\c6Thank you, come again.");
			case 3:
				messageClient(%client, '', "\c6No such category.");
			case 4:
				messageClient(%client, '', "\c6No such item.");
		}
		cancel(%client.shopping);
		%client.shopping = false;
	}
}
