
package Skills
{
	function Armor::onTrigger(%datablock,%player,%slot,%io)
	{
		// 0 Fire
		// 1 Jump
		// 3 Crouch
		// 4 Jet
		
		// Parry / Block
		if(%slot == 4 && %player.client.RPG["skill_block"])
		{
			if(%player.tool[%player.currTool].uiName $= "Long Sword" && %io == 1)
			{
				%player.playthread(2, spearReady);
				%player.blocking = true;
			}
			if(%player.tool[%player.currTool].uiName $= "Long Sword" && %io == 0)
			{
				if(!%player.parrying)
					%player.playthread(2, root);
				%player.blocking = false;
			}
		}
		if(%slot == 4 && %player.client.RPG["skill_parry"])
		{
			if(%player.tool[%player.currTool].uiName $= "Long Sword" && %io == 1)
			{
				%player.playthread(2, spearReady);
				%player.parrying = true;
				%player.schedule(150, notParrying);
			}
		}
		// Sprint
		if(%slot == 4 && %player.client.RPG["class"] $= "Thief" && %player.dataBlock $= "PlayerRPG" && %io == 1)
		{
			if(%player.tired)
			{
				echo("1tired:" SPC %player.tired);
				%player.client.centerPrint("You are tired", 2);
			}
			else
			{
				echo("2tired:" SPC %player.tired);
				%player.changedatablock("PlayerFastRPG");
				%player.tired = true;
				%player.schedule(5000, changeDataBlock, "PlayerRPG");
				%player.schedule(10000, sprintReady);
			}
		}
		// Double Jump
		if(%slot == 2 && %player.client.RPG["class"] !$= "Thief" && %io == 1 && !%player.isOnGround() && ((%player.lastDoubleJump + 2000) < getSimTime()))
		{
			%player.lastDoubleJump = getSimTime();
			%scale = getWord(%player.getScale(), 2) / 2;
			%vel = vectorScale("0 0 25", %scale);
			%player.addVelocity(%vel);
			%player.playSound(jumpSound);
		}
		Parent::onTrigger(%datablock,%player,%slot,%io);
	}
};//activatePackage(Skills);

function Player::notParrying(%player)
{
	%player.parrying = false;
	if(!%player.blocking)
		%player.playthread(2, root);
}

function Player::sprintReady(%player)
{
	%player.tired = false;
}

package magic_mirror
{
	function ProjectileData::Damage(%this, %obj, %col, %fade, %pos, %normal)
	{
		if(%col.getClassName() $= Player || %col.getClassName() $= AIPlayer)
		{
		//if(%col.reflecting)
		//{
			%obj.schedule(33, bounce, 1, %obj.sourceObject.client);
			return;
		//}
		}
		Parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
	}
};//activatepackage(magic_mirror);
