
datablock fxDtsBrickData(DropOffBrickData : brick2x2RampPrintData)
{
	category = "Special";
	subcategory = "RPG";
	
	uiName = "Drop-off";
	
	specialBrickType = "DropOff";
};
	
package BRPG_DropOffBrick
{
	function fxDtsBrick::OnActivate(%obj, %player, %client, %pos, %vec)
	{
		if(%obj.dataBlock.specialBrickType $= "DropOff" && RPG_Minigamecheck(%client, 1))
		{
			messageClient(%client, '', "\c3Sell resources");
			messageClient(%client, '', "\c31. \c6Sell ore");
			messageClient(%client, '', "\c30. \c6Exit");
			
			if(%client.shopping)
				cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			%client.shoppingBrick = %obj;
		}
		Parent::OnActivate(%obj, %player, %client, %pos, %vec);
	}
	function ServerCmdMessageSent(%client, %text)
	{
		if(%client.shopping && %client.shoppingBrick.dataBlock.specialBrickType $= "DropOff" && RPG_Minigamecheck(%client, 1))
		{
			cancel(%client.shopping);
			%client.shopping = %client.schedule(20000, stopShopping, 1);
			
			switch$(%text)
			{
				case 1:
					if(%client.RPG["ore"] > 0)
					{
						messageClient(%client, '', "\c3You sell ore for" SPC %client.RPG["ore"] SPC "gold");
						%client.RPG["gold"] += %client.RPG["ore"];
						%client.RPG["ore"] = 0;
						%client.stopShopping();
					}
					else
					{
						messageClient(%client, '', "\c3You have no ore!");
						%client.stopShopping();
					}
				default:
					%client.stopShopping(1);
			}
		}
		else
			Parent::ServerCmdMessageSent(%client, %text);
	}
};activatepackage(BRPG_DropOffBrick);