
$RPG_region[""] = "Loading";
$RPG_region[0] = "Loading";
$RPG_region[1] = "Hills";
$RPG_region[2] = "Dark Woods";
$RPG_region[3] = "Field";
$RPG_region[4] = "Viking Territory";
$RPG_region[5] = "Battlegrounds";
$RPG_defaultRegion = 1;
$RPG_defaultDistrict = 1;

package BRPG_chat
{
	function GameConnection::spawnPlayer(%client)
	{
		if(RPG_MinigameCheck(%client))
		{
			if(!%client.RPG["region"] || !%client.checkPointBrick)
				%client.setRegion($RPG_defaultRegion);
			if(!%client.RPG["district"] || !%client.checkPointBrick)
				%client.setDistrict($RPG_defaultDistrict);
		}
		parent::spawnPlayer(%client);
	}
	function serverCmdMessageSent(%client, %text, %global)
	{
		if(!$RPG_localChatEnabled || !RPG_MinigameCheck(%client))
			return Parent::serverCmdMessageSent(%client, %text);
			
		echo(%client.name @ ":" SPC %text);
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			//echo("target:" SPC %target);
			//echo("client region:" SPC %client.RPG["region"]);
			//echo("target region:" SPC %target.RPG["region"]);
			if(%client.RPG["region"] == %target.RPG["region"])
			{
				if(%client.RPG["pvp"])
				{
					messageClient(%target, '', '\c2[%5] \c7%1\c0%2\c7%3\c6: %4', %client.clanPrefix, %client.name, %client.clanSuffix, %text, $RPG_region[%client.RPG["region"]]);
					%count++;
				}
				else
				{
					messageClient(%target, '', '\c2[%5] \c7%1\c3%2\c7%3\c6: %4', %client.clanPrefix, %client.name, %client.clanSuffix, %text, $RPG_region[%client.RPG["region"]]);
					%count++;
				}
			}
		}
		if(%count == 1 && %client.RPG["region"] == 0)
		{
			messageClient(%client, '', "\c4You can only chat with others who are loading right now.");
		}
	}
	function serverCmdTeamMessageSent(%client, %text)
	{
		if(!$RPG_localChatEnabled || !RPG_MinigameCheck(%client))
			return Parent::serverCmdTeamMessageSent(%client, %text);
			
		echo("(T)" SPC %client.name @ ":" SPC %text);
//		%guild = %client.RPG["guild"];
//		if(%guild $= "")
//		{
//			messageClient(%client, '', "\c4Guild chat disabled - You are not in a guild.");
//			return;
//		}
//		if(!%client.RPG["pvp"])
//		{
//			messageClient(%client, '', "Guild chat disabled - You are not in PvP.");
//			return;
//		}
//		for(%i = 0; %i < ClientGroup.getCount(); %i++)
//		{
//			%target = ClientGroup.getObject(%i);
//			if(%client.RPG["region"] == %target.RPG["region"] && %client.RPG["guild"] $= %target.RPG["guild"] && %target.RPG["pvp"])
//			{
//				messageClient(%target, '', '\c2[%5] \c7%1\c0%2\c7%3\c6:\c4 %4', %client.clanPrefix, %client.name, %client.clanSuffix, %text, $RPG_region[%client.RPG["region"]]);
//			}
//		}
	}
};
activatepackage(BRPG_chat);

function serverCmdSetRegion(%client,%region)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	if(%client.isAdmin)
		%client.setRegion(%region);
}