
package BRPG_Minigames
{
	function miniGameCanDamage(%a, %b)
	{
		return 1;
	}	
	function miniGameCanUse(%a, %b)
	{
		return 1;
	}
};//activatepackage(BRPG_Minigames);

package TeamDeathMatch
{
	function miniGameCanUse(%a, %b)
	{
		return 1;
	}
};//activatepackage(TeamDeathMatch);

// Event_Bots
package RPG_Event_Bots
{
	function fxDTSbrick::botVehicleSpawn(%this)
	{
		if(isObject(%obj = %this.vehicle))
		{
			if(%obj.getClassName() $= "AIplayer" && isObject(%brick = %obj.spawnBrick))
			{
				//Default AI values:
				%obj.inactive = true;
				%obj.aggressive = false;
				%obj.defendself = false;
				%obj.canmove = true;
				%obj.canaim = true;
				%obj.sightrange = 20;
				%obj.fov = 180;
				%obj.leashlength = 50;
				%obj.clawdamage = 0;

				%obj.spawnPosition = %obj.getPosition();
				%data = %obj.getDatablock();
				if(!%obj.isZombie) //This stuff screws with zombies
				{
					// RPG: Fix memory leak
					//%obj.mountImage(BlankImage, 2);
					//%obj.mountImage(BlankImage, 3);
					%client = %this.getGroup().client;
					%obj.client = new AIconnection()
					{
						bot = %obj;
						minigame = %client.minigame;
						brickGroup = %client.brickGroup; //So the owner can still ride bot vehicles (like the horse and cannon)
					};
					MissionCleanup.add(%obj.client);
				}
				$InputTarget_["Self"] = %brick;
				$InputTarget_["Bot"] = %obj;
				%this.processInputEvent("onBotSpawn", %this.getGroup().client);
			}
		}
	}
	function Armor::onRemove(%this, %obj)
	{
		if(%obj.client)
		{
			if(%obj.client.getClassName() $= "AIconnection")
			{
				//echo("force clientdelete");
				%obj.client.delete();
			}
		}
		Parent::onRemove(%this, %obj);
	}
	function fxDTSbrick::processInputEvent(%brick, %event, %client)
	{
		if(%event $= "onBotSpawn" || %event $= "onBotTouched" || %event $= "onBotKilled" || %event $= "onBotTouch" || %event $= "onBotSpawn")
		{
			if(!isObject($RPG_dummyclient))
			{
				//echo("CREATING DUMMYCLIENT");
				$RPG_dummyclient = new GameConnection();
				MissionCleanup.add($RPG_dummyclient);
				//$RPG_dummyclient.minigame = $DediMinigames[199];
			}
			%client = $RPG_dummyclient;
		}
		Parent::processInputEvent(%brick, %event, %client);
	}
};activatepackage(RPG_Event_Bots);

