
package RPG_Mining
{
	function rpgPickaxeProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		%client = %obj.sourceObject.client;
		if(%col.dataBlock.specialBrickType $= "Ore")
		{
			if(%col.empty)
				%client.centerPrint("\c3The ore is gone!", 1);
			else
			{	
				%client.centerPrint("\c3You swing your pick at the rock...", 1);
				if(getRandom(1, 100) > 100 - %col.dataBlock.mineChance)
				{
					%client.centerPrint("\c3You get some" SPC %col.dataBlock.uiName @"!", 1);
					%client.RPG["ore"] += %col.dataBlock.oreValue;
					%col.empty = true;
					
					%col.schedule(%col.dataBlock.restoreTime, restoreOre);
					%col.setColor(%col.dataBlock.brickColor + 15);
				}
			}
		}
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	}
};
activatePackage(RPG_Mining);

function fxDTSBrick::restoreOre(%this)
{
	%this.empty = false;
	%this.setColor(%this.dataBlock.brickColor);
}