
if(!isFile("config/server/BasicRPG/monsterData.txt"))
{
	$readFile = new fileObject();
	$readFile.openForWrite("config/server/BasicRPG/monsterData.txt");
	$readFile.writeLine("[Name]" TAB "[Exp]" TAB "[Gold]" TAB "[Atk]" TAB "[Def]" TAB "[M.Def]" TAB "[HP]");
	$readFile.writeLine("Horse" TAB "0" TAB "0" TAB "0" TAB "0" TAB "0" TAB "250");
	$readFile.writeLine("Bandit" TAB "10" TAB "10" TAB "4" TAB "0" TAB "0" TAB "50");
	$readFile.close();
	$readFile.delete();
}

$readFile = new fileObject();
$readFile.openForRead("config/server/BasicRPG/monsterData.txt");
$readFile.readLine();
while(!$readFile.isEOF())
{
	$readLine = $readFile.readLine();
	$MonsterData::Exp[getField($readLine,0)] = getField($readLine,1);
	$MonsterData::Loot[getField($readLine,0)] = getField($readLine,2);
	$MonsterData::Attack[getField($readLine,0)] = getField($readLine,3);
	$MonsterData::Defense[getField($readLine,0)] = getField($readLine,4);
	$MonsterData::MagicDefense[getField($readLine,0)] = getField($readLine,5);
	$MonsterData::HP[getField($readLine,0)] = getField($readLine,6);
}
$readFile.close();
$readFile.delete();


$RPG::district["_overworld"] = true;
$RPG::district["0_overworld"] = true;

if(!isObject($RPG_fileObject))
	$RPG_fileObject = new fileObject();
		
$RPG_fileObject.openForRead("config/server/BasicRPG/overworld_districts.txt");

while(!$RPG_fileObject.isEOF())
{
	%line = $RPG_fileObject.readLine();
	if(getField(%line,0) == 0)
		continue;
	
	%count++;
	%id = getField(%line, 0);
	
	$RPG::district_table[%count] = %id;
	$RPG::district[%id @ "_overworld"] = true;
	$RPG::district[%id @ "_x1"] = getField(%line, 1);
	$RPG::district[%id @ "_y1"] = getField(%line, 2);
	$RPG::district[%id @ "_x2"] = getField(%line, 3);
	$RPG::district[%id @ "_y2"] = getField(%line, 4);
	$RPG::district[%id @ "_region"] = getField(%line, 5);
}
$RPG::districts = %count;
$RPG_fileObject.close();

function checkRegion(%client)
{
	if(!isObject(%client.player))
		return;
	if($RPG::district[%client.RPG["district"] @ "_overworld"] == false)
		return;
	%pos = %client.player.getPosition();
	%x = getWord(%pos,0);
	%y = getWord(%pos,1);
	if($RPG_coords && %client.bl_ID == 199)
		echo("X:" SPC %x SPC "" SPC "Y:" SPC %y);
	%district = 0;
	for(%i = 1; %i <= $RPG::districts; %i++)
	{
		%id = $RPG::district_table[%i];
		if(%x >= $RPG::district[%id @ "_x1"] && %y >= $RPG::district[%id @ "_y1"])
			if(%x < $RPG::district[%id @ "_x2"] && %y < $RPG::district[%id @ "_y2"])
				%district = %id;
	}
	%client.setDistrict(%district);
	%client.setRegion($RPG::district[%district @ "_region"]);
}

//connect this to serverCmdVehicleSpawn_Respawn instead ?
//or Armor::onDisabled ??
package fixbotrespawncrash
{
	function Armor::onRemove(%this, %obj)
	{
		if(%obj.client)
		{
			if(%obj.client.getClassName() $= "AIconnection")
			{
				echo("force clientdelete");
				%obj.client.delete();
			}
		}
		Parent::onRemove(%this, %obj);
	}
};//activatepackage(fixbotrespawncrash);

package disableVehicleSpawning
{
	function fxDTSbrick::setVehicle(%brick, %vehicle)
	{
		%client = %brick.getGroup().client;
		switch$(%vehicle.UIname)
		{
			case "":
				parent::setVehicle(%brick, %vehicle);
//			case "Barrel":
//				parent::setVehicle(%brick, %vehicle);
//			case "Standard Bot":
//				parent::setVehicle(%brick, %vehicle);
			default:
				if(%client.isSuperAdmin)
					parent::setVehicle(%brick, %vehicle);
				else
					commandToClient(%client, 'centerPrint', "Vehicle spawning is disabled.", 2);
		}		
	}
};//activatepackage(disableVehicleSpawning);
