
package BRPG_MakeThingsWork
{
	// Spawn in RPG
	function GameConnection::spawnPlayer(%client)
	{
		if(!RPG_MinigameCheck(%client))
			return Parent::spawnPlayer(%client);
		
		%client.schedule(100, RPGPlayerLoop);
		
		// Make sure the item table works
		if(!$uinametable_items["Hammer "])
			createUiNameTable();
		
		if(%client.RPG["char"] < 1)
			%client.RPG["char"] = charCheck(%client, 1);
		%client.loadStats();
		
		Parent::spawnPlayer(%client);
		
		%client.schedule(50, updateDataBlock);
		//%client.schedule(150, updatePvP);

		updateMaxHP(%client);
		updateMaxMP(%client);
		updateArrows(%client);
		
		%client.RPG["hp"] = %client.RPG["maxhp"];
		%client.RPG["mp"] = %client.RPG["maxmp"];
		
		if(%client.RPG["pvp"])
			%client.player.setShapeNameColor("0.09 0.09 0.09 1");
		else
			%client.player.setShapeNameColor("1 1 1 1");
		//if(%client.RPG["guild"] !$= "")
		//	%client.player.setShapeNameColor(getColorIDTable($GuildData::Color[%client.RPG["guild"]]));
	}
	function serverCmdLeaveMiniGame(%client)
	{
		parent::serverCmdLeaveMiniGame(%client);
		//%client.player.instantrespawn();
	}
	function serverCmdEndMiniGame(%client)
	{
		parent::serverCmdEndMiniGame(%client);
		%client.player.instantrespawn();
	}
	function serverCmdCreateMiniGame(%client, %name, %a, %b)
	{
		if(%client.isSuperAdmin)
			parent::serverCmdCreateMiniGame(%client, %name, %a, %b);
	}
	function MiniGameSO::forceEquip(%a, %b)
	{
	}
	function MiniGameSO::updatePlayerDataBlock(%a)
	{
	}
};activatepackage(BRPG_MakeThingsWork);

function GameConnection::updatePvP(%client)
{
	if(%client.minigame != 0)
		enterpvp(%client);
}